# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-xacml/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag %{nil}
%define namedversion %{version}
%define oname jboss-security-xacml

Name:           jboss-security-xacml
Version:        2.0.5
Release:        1%{?dist}
Epoch:          0
Summary:        JBoss Security XACML
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
#svn export https://svn.jboss.org/repos/jbossas/projects/security/security-xacml/tags/2.0.5/ jboss-security-xacml-2.0.5
#Exported revision 108533.
#tar cjf jboss-security-xacml-2.0.5.tar.bz2 jboss-security-xacml-2.0.5

Source0:        jboss-security-xacml-2.0.5.tar.bz2
Source1:        jboss-security-xacml-jpp-depmap.xml
Source2:        jboss-security-xacml-settings.xml
Source3:        jboss-security-component-info.xml
BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       codehaus-stax11
Requires:       jaf_1_1_api
Requires:       jaxb_2_1_api
Requires:       stax_1_0_api
Requires:       glassfish-jaxb
Requires:       servlet_2_5_api
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
BuildRequires:  hsqldb
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  junit4
BuildRequires:  codehaus-stax11
BuildRequires:  glassfish-jaxb
BuildRequires:  jaf_1_1_api
BuildRequires:  jaxb_2_1_api
BuildRequires:  jboss-parent
BuildRequires:  servlet_2_5_api
BuildRequires:  stax_1_0_api
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-commons
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Security XACML.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}-%{namedversion} 

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}/%{name}
install -p -m 644 assembly/target/jbossxacml-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jbossxacml-%{version}.jar
install -p -m 644 assembly/target/jbossxacml-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/jbossxacml-sources-%{version}.jar
install -p -m 644 jboss-sunxacml/target/jboss-sunxacml-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jboss-sunxacml-%{version}.jar
install -p -m 644 jboss-sunxacml/target/jboss-sunxacml-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/jboss-sunxacml-sources-%{version}.jar
install -p -m 644 jboss-xacml/target/jboss-xacml-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jboss-xacml-%{version}.jar
install -p -m 644 jboss-xacml/target/jboss-xacml-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/jboss-xacml-sources-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms

%add_to_maven_depmap org.jboss.security jboss-xacml-project %{namedversion} JPP/%{name} %{name}-project
install -p -m 644 parent/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-project.pom

%add_to_maven_depmap org.jboss.security jbossxacml %{namedversion} JPP/%{name} jbossxacml
install -p -m 644 assembly/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossxacml.pom

%add_to_maven_depmap org.jboss.security jboss-xacml-main %{namedversion} JPP/%{name} %{name}-main
install -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-main.pom

%add_to_maven_depmap org.jboss.security jboss-sunxacml %{namedversion} JPP/%{name} jboss-sunxacml
install -p -m 644 jboss-sunxacml/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-sunxacml.pom

%add_to_maven_depmap org.jboss.security jboss-xacml %{namedversion} JPP/%{name} jboss-xacml
install -p -m 644 jboss-xacml/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-xacml.pom

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jbossxacml.jar %{buildroot}%{repodirlib}/jbossxacml.jar
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jbossxacml-sources.jar %{buildroot}%{repodirlib}/jbossxacml-sources.jar
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jboss-sunxacml.jar  %{buildroot}%{repodirlib}/jboss-sunxacml.jar
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jboss-sunxacml-sources.jar %{buildroot}%{repodirlib}/jboss-sunxacml-sources.jar
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jboss-xacml.jar %{buildroot}%{repodirlib}/jboss-xacml.jar
install -p -m 644 %{buildroot}%{_javadir}/%{name}/jboss-xacml-sources.jar %{buildroot}%{repodirlib}/jboss-xacml-sources.jar
install -p -m 644 %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossxacml.pom %{buildroot}%{repodirlib}/jbossxacml.pom
install -p -m 644 %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-xacml-main.pom %{buildroot}%{repodirlib}/jboss-security-xacml-main.pom
install -p -m 644 %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-xacml-project.pom %{buildroot}%{repodirlib}/jboss-security-xacml-project.pom
install -p -m 644 %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-sunxacml.pom %{buildroot}%{repodirlib}/jboss-sunxacml.pom
install -p -m 644 %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-xacml.pom %{buildroot}%{repodirlib}/jboss-xacml.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/jbossxacml-%{version}.jar
%{_javadir}/%{name}/jbossxacml.jar
%{_javadir}/%{name}/jbossxacml-sources-%{version}.jar
%{_javadir}/%{name}/jbossxacml-sources.jar
%{_javadir}/%{name}/jboss-sunxacml-%{version}.jar
%{_javadir}/%{name}/jboss-sunxacml.jar
%{_javadir}/%{name}/jboss-sunxacml-sources-%{version}.jar
%{_javadir}/%{name}/jboss-sunxacml-sources.jar
%{_javadir}/%{name}/jboss-xacml-%{version}.jar
%{_javadir}/%{name}/jboss-xacml.jar
%{_javadir}/%{name}/jboss-xacml-sources-%{version}.jar
%{_javadir}/%{name}/jboss-xacml-sources.jar
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-xacml-main.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-xacml-project.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossxacml.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-sunxacml.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-xacml.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Oct 14 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.5-1
- Upgrade to 2.0.5
- Change BR: maven-surefire-provider-junit to maven-surefire-provider-junit4, add its depmap entry
- Change BR: junit to junit4, change its depmap entry
- Add BR: hsqldb, add depmap entry

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-4.1.1
- rebuilt

* Thu Apr 08 2010 Hui Wang <huwang@redhat.com> 0;2.0.4-4.1
- Rebuild for generating signed jar

* Fri Sep 18 2009 David Walluck <dwalluck@redhat.com> 0:2.0.4-4
- properly build and install jbossxacml
- add all sources jars
- install all jars and poms to repolib

* Thu Aug 13 2009 Permaine Cheung <pcheung@redhat.com> 0:2.0.4-3
- Fix component-info.xml

* Thu Aug 13 2009 Permaine Cheung <pcheung@redhat.com> 0:2.0.4-2
- Add sources.jar

* Wed Aug 12 2009 Permaine Cheung <pcheung@redhat.com> 0:2.0.4-1
- Upgrade to 2.0.4
- Fix repodir

* Mon Jul 27 2009 Yong Yang <yyang@redhat.com> 0:2.0.3.SP2-2
- Combine jboss-sunxacml.jar and jboss-xacml.jar to repolib/jbossxacml.jar

* Thu Jul 16 2009 Yong Yang <yyang@redhat.com> 0:2.0.3.SP2-1
- Switch to 2.0.3.SP2

* Mon Jul 13 2009 David Walluck <dwalluck@redhat.com> 0:2.0.3-4
- update (Build)Requires

* Mon Jul 13 2009 David Walluck <dwalluck@redhat.com> 0:2.0.3-3
- fix component-info.xml

* Mon Jul 13 2009 David Walluck <dwalluck@redhat.com> 0:2.0.3-2
- fix sources

* Wed Jul 01 2009 David Walluck <dwalluck@redhat.com> 0:2.0.3-1
- 2.0.3
- add repolib
- use glassfish-jaxb

* Tue Jun 16 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.3-0.CR5.1.jpp5
- 2.0.3.CR5 

* Fri Jun 05 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.2.1-1.jpp5
- 2.0.2.SP1
